//  - 
// (c) Proteus   lawnmower-man@mail.ru

#include<stdio.h>

//!    -
class Tree{
	//!   (    
	struct node_st{
		//!  
		enum ft{
			f_end =1,	//!<        
			f_link=2	//!< next      ( next    )
		};
		node_st *next;		//!<     ( )
		node_st *child;		//!<   (  )
		char     sym;		//!<  
		char     flags;		//!< 
		node_st(char s) {next=child=0;flags=0;sym=s;}
	};
	node_st *root;						//!<  
	node_st *Check(node_st*,node_st*);	
	void Init(node_st*,node_st*);
	void Optimize(node_st*);			//!<  
	void Clear(node_st*);				//!<  
	void Dump(node_st*,int);
public:
	Tree();
	~Tree();
	void Add(char *line);	//!<    
	void Init();			//!<     (    )
	void Dump();			//!<  
	char *Find(char*);		//!<   

};

Tree::Tree()
{
	root=0;
}

Tree::~Tree()
{
	Clear(root);
}

void Tree::Clear(node_st *node)
{
	while(node) {
		if(!(node->flags&node_st::f_link)) Clear(node->next);
		node_st *child=node->child;
		delete node; 
		node=child;
	}
}

//! \param line    
void Tree::Add(char *line)
{
	node_st *last,**ref;
	last=*(ref=&root);	// last   ,   
	while(*ref && *line) {  //       
		last=*ref;
		ref=(last->sym==*line)?(line++,&last->child):(ref=&last->next);
	}
	while(*line) {	//      
		last=*ref=new node_st(*line++); 
		ref=&last->child;
	};
	last->flags|=node_st::f_end;	//   
}


//!   ,    
void Tree::Init()
{
	node_st *node=root;
	while(node)	Init(node->child,root),node=node->next;
	//---  Optimize(root);
}




//!    
//! \param node      
//! \param    s     
Tree::node_st *Tree::Check(node_st *node,node_st *s)
{
	while(node) {
		if(node==s) break;	//       ( )
		if(node->sym==s->sym) return node;
		node=node->next;
	}
	return 0;
}

//! \param node     
//! \param link      
void Tree::Init(node_st *node,node_st *link)
{
	node_st *bad;
	while(node) {
		Init(node->next,link);							//  
		if(!node->next) node->flags|=node_st::f_link;	//      (     ,      )
		bad=Check(link,node);							//     
		if(!bad) bad=Check(root,node);
		if(!node->next) node->next=link;
		link=bad?bad->child:root;
		node=node->child; 
	}	
}


//!     .      ,
//!            
//!            
//!   ,     .
void Tree::Optimize(node_st *node)
{
	while(node) {
		if(node->flags&node_st::f_link) {	//   init
			for(;;){
				node_st *next=node->next;
				if(next && node->sym==next->sym) node->next=next->next; else break;
			}
		}else Optimize(node->next);
		node=node->child;
	}
}



//!        
//! \param text      
//! \result      
char* Tree::Find(char *text)
{
	node_st *node=0;
	while(*text) {
		if(!node) node=root;
		while(node) {
			if(node->sym==*text) {
				if(node->flags&node_st::f_end) return text;
				node=node->child;
				break;
			} else node=node->next;
		}
		text++;
	}
	return 0;
}

void Tree::Dump(node_st *node,int depth)
{
	while(node) {
		printf("[%x] %c%c",node,node->sym,node->flags&node_st::f_end?'$':' ');
		if(node->next) {
			printf(node->flags&node_st::f_link?"     link->%x":"  next=>%x",node->next);
		}		putchar('\n');
		if(!(node->flags&node_st::f_link)) Dump(node->next,depth);
		node=node->child;
	}
}

void Tree::Dump()
{
	Dump(root,0);
}


void main()
{
	Tree tree;
	char *list[]={"potato","at","pot","tatter","tatto","theater","other",0};
	for(int n=0; list[n]; n++) tree.Add(list[n]);
	tree.Init();
	tree.Dump();
	
	char *t=tree.Find("apsodadoaspdoapopaoapodapodpaoada");
	printf("done.\n");
	getchar(); 
}
